function df = function_df_intval(N,R,j,u);
% compute nonlinear differentiation of f[u]*phi_j by interval arithmetic
  df = intval(zeros(2*N,1));
  m = (1:N)';
  s = u(m).*(intval(m).^2-j^2);
  n = m+j;
  df(n) = df(n) + s.*(-m+j);
  p = m-j;  q = m+j;
  t = find(p>0);  df( p(t)) = df( p(t)) + s(t).*q(t);
  t = find(p<0);  df(-p(t)) = df(-p(t)) - s(t).*q(t);
  df = intval(R)/intval('2')*df;



