function f = function_f(N,R,k,u);
% compute nonlinear function f by floating point arithmetic
  f = zeros(2*N,1);
  n=(1:N)';
  W = u*(u.*(n.^2))';  % NxN matrix for u*u*n^2
  for m = 1:N
    s = W(m,:);
    f(n+m) = f(n+m) + s'.*(m-n);
    p = m-n;  l = m+n;
    t = find(p>0);  f( p(t)) = f( p(t)) - s(t)'.*l(t);
    t = find(p<0);  f(-p(t)) = f(-p(t)) + s(t)'.*l(t);
  end
  f = R/2*f;
  f(k) = f(k) + 1;
