function f = function_f_intval(N,R,k,u);
% compute nonlinear function f by interval arithmetic
  f = intval(zeros(2*N,1)); v = intval(u);
%
% code 1
%  for m = 1:N
%  formatSpec = '%6d / %-6d\n';  fprintf(formatSpec,m,N)
%  for n = 1:N
%    s = u(m)*u(n)*n^2;
%    i = m+n;
%    f(i) = f(i) + s*(m-n);
%    t = sign(m-n);
%    i = abs(m-n);
%    if i~=0
%      f(i) = f(i) - t*s*(m+n);
%    end  
%  end
%  end
%
% code 2
%  for m = 1:N
%    formatSpec = '%6d / %-6d\n';  fprintf(formatSpec,m,N)
%    for n = 1:m-1
%      s = v(m)*v(n)*n^2;
%      i = m+n;
%      f(i) = f(i) + s*(m-n);
%      i = m-n;
%      f(i) = f(i) - s*(m+n);
%    end
%    for n = m+1:N
%      s = v(m)*v(n)*n^2;
%      i = m+n;
%      f(i) = f(i) + s*(m-n);
%      i = n-m;
%      f(i) = f(i) + s*(m+n);
%    end
%  end
%
% code 3
%   w = ((1:N).^2)';  v = u.*w;
%   W = u*v';
%   for m = 1:N
%     formatSpec = '%6d / %-6d\n';  fprintf(formatSpec,m,N)
%     for n = 1:m-1
%       s = W(m,n);
%       i = m+n;
%       f(i) = f(i) + s*(m-n);
%       i = m-n;
%       f(i) = f(i) - s*(m+n);
%     end
%     for n = m+1:N
%       s = W(m,n);
%       i = m+n;
%       f(i) = f(i) + s*(m-n);
%       i = n-m;
%       f(i) = f(i) + s*(m+n);
%     end
%  end
% code 4
   n=(1:N)';
   W = u*(u.*(n.^2))';  % NxN matrix for u*u*n^2
   for m = 1:N
     s = W(m,:);
     f(n+m) = f(n+m) + s'.*(m-n);
     p = m-n;  l = m+n;
     t = find(p>0);  f( p(t)) = f( p(t)) - s(t)'.*l(t);
     t = find(p<0);  f(-p(t)) = f(-p(t)) + s(t)'.*l(t);
   end
  f = R/intval(2)*f;
  f(k) = f(k) + 1;



