function [z3,z9,C,C0,C1] = norms(N,R,k,u);
% This MATLAB file computes some bounds for obtained approximate solution.

  one = intval('1');  Pi = intval('pi'); s = Pi/intval('2');

  f = function_f_intval(N,R,k,u);

  v = (intval(1:N).^4)' .* u;
  x = intval(zeros(2*N,1));
  x(1:N) = v;    
  d = x - f;
  t1 = sup(sqrt(s)*norm(d));

  z3 = intval(zeros(N,1));
  z3(1:N) = s*d(1:N);
  t2 = max(mag(z3));

  x = d(N+1:2*N);
  
  z9 = intval(sup(sqrt(s)*norm(x)));

  formatSpec = 'defect:%10.4e  |z3|:%10.4e  z9:%10.4e\n';
  fprintf(formatSpec,t1,t2,sup(z9))

   C = one/((N+1)*one);
  C0 = sqrt(intval('2')/(intval('5')*Pi*(one*N)^5));
  C1 = sqrt(intval('2')/(intval('3')*Pi*(one*N)^3));



