  intvalinit('displayinfsup');
  intvalinit('sharpivmult')  % use sharp interval matrix multiplication
  format long;
  input_data

  M = 10;  % range partition number
  Pi = intval('pi');   unit = intval('[0,1]');
  zero = intval(zeros(M,1));

  load('u.dat','-mat');
  load('w.dat','-mat'); w=d;
  load('alpha.dat','-mat'); alpha=beta;

  % generate M-th subintervals on (0,Pi)
  I = zero;
  for i = 1: M
    I(i) = Pi*(unit + i - 1)/M;
  end
  
  % compute range of u'(x) on each subintervals 
  v = u + w;  v = (1:N)' .* v;
  C1 = sqrt(intval(2)/(3*Pi*N^3));
  R1 = zero;  R1(:) = intval('[-1,1]')*C1*alpha;
  for i = 1: M
    R1(i) = sum(v*cos(I(i)));
  end

  % compute range of u''(x) on each subintervals 
  v = u + w;  v = ((1:N).^2)' .* v;
  C2 = sqrt(intval(2)/(Pi*N));
  R2 = zero;  R2(:) = intval('[-1,1]')*C2*alpha;
  for i = 1: M
    R2(i) = sum(-v*sin(I(i)));
  end
  % confirm signs and monotonicity 
  t1 = find(in(0,R1));  t2 = find(~in(0,R2));
  if intersect(t1,t2) == t1
    disp('Unimodality is assured!'); 
    X = zeros(2*M,1);  Y1 = intval(X);   Y2 = intval(X);
      for i = 1:M-1
        X(2*(i-1)+1) = inf(I(i));   X(2*(i-1)+2) = sup(I(i)); 
        Y1(2*(i-1)+1) = R1(i);      Y1(2*(i-1)+2) = R1(i);
        Y2(2*(i-1)+1) = R2(i);      Y2(2*(i-1)+2) = R2(i);
      end
      X(2*M-1) = inf(I(M));   X(2*M) = sup(I(M)); 
      Y1(2*M-1) = R1(M);      Y1(2*M) =   R1(M); 
      Y2(2*M-1) = R2(M);      Y2(2*M) =   R2(M); 
      figure
      hold on
        plot(X,sup(Y1),'LineWidth',5,'Color','k')
        plot(X,inf(Y1),'LineWidth',5,'Color','k')
        plot(X,sup(Y2),'LineWidth',5,'Color','b','LineStyle',':')
        plot(X,inf(Y2),'LineWidth',5,'Color','b','LineStyle',':')
        axis([0,pi,-2.1,2.1])
        str = '$$u''(x)>0$$'; text(0.8,1.8,str,'Interpreter','latex')
        str = '$$u''(x)<0$$'; text(2.5,1.8,str,'Interpreter','latex')
        str = '$$u''{''}(x)\neq 0$$'; text(2,1,str,'Interpreter','latex')
      hold off
  end 
