function [z1,z2,z4,z5,z6,z7,z8] = zs(N,u,w)
% This MATLAB file computes some bounds in FN-Int

  Pi = intval('pi');
   v = u + w;

% -=-=-=-=-= z1 -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= %
  s = sqrt(Pi/intval('2'));
  zero = intval('0'); z1 = intval(zeros(N,1));    
  for i = 1:N;
    e = intval(zeros(2*N,1));   m = (1:N)';
    s1 = (i+2.*m).^2.*v(m);  s2 = (i-2.*m).^2.*v(m);
    n = m+i;
    e(n) = e(n) + s1;
    p = m-i;
    t = find(p>0);  e( p(t)) = e( p(t)) + s2(t);
    t = find(p<0);  e(-p(t)) = e(-p(t)) - s2(t);
    e = -i/2*e;
    e(1:N) = zero;
    z1(i) = intval(sup(s*norm(e)));
  end 


% -=-=-=-=-= z2 -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= %
  n = (1:N)';
  e = intval(zeros(2*N,1));  
  W = w*(w.*(n.^2))';
  for m = 1:N
    s = W(m,:);
    e(n+m) = e(n+m) + s'.*(m-n);
    p = m-n;  l = m+n;
    t = find(p>0);  e( p(t)) = e( p(t)) - s(t)'.*l(t);
    t = find(p<0);  e(-p(t)) = e(-p(t)) + s(t)'.*l(t);
  end
  e = e/2;
  s = Pi/intval('2');
  z2 = s*e(1:N);


% -=-=-=-=-= z4 -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= %
  e = intval(zeros(2*N,1));
  W = v*(w.*(n.^2))' + w*(u.*(n.^2))';
  for m = 1:N
    s = W(m,:);
    e(n+m) = e(n+m) + s'.*(m-n);
    p = m-n;  l = m+n;
    t = find(p>0);  e( p(t)) = e( p(t)) - s(t)'.*l(t);
    t = find(p<0);  e(-p(t)) = e(-p(t)) + s(t)'.*l(t);
  end
  e = e/2;
  zero = intval('0');  e(1:N) = zero;
  s = sqrt(Pi/intval('2'));
  z4 = intval(sup(s*norm(e)));


% -=-=-=-=-= z5, z6, z7, and z8 -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-= %
  z5 = intval(sup(norm(v,1)));

  p = intval(n);
  q = p .* v;      
  z6 = intval(sup(norm(q,1)));

  q = p.^2 .* v;
  z7 = intval(sup(norm(q,1)));

  q = p.^3 .* v;
  z8 = intval(sup(norm(q,1)));
